#REM				    Charge Controller
				       Ver 2006C
				   www.thebackshed.com

				     Modified by Gill
		 for Smart Taper PWM Regulation and 3 x Source Input
			  with full PC logging via Serial or Radio
				  for 12 to 24 Volt battery 

 ****with a user set Taper Amps Threshold & selectable Output Mode for the logging of data****	
#ENDREM



	#picaxe 28X1				;commands Programming Editor to use its 28X1 settings



Start:
	;Caution(b0 & b1)	= w0			  much tempoary use 
	SYMBOL  BatAmp	= b2			; Battery Amps (metered)
	SYMBOL  Volt	= b3			; Battery Volts (metered)
	SYMBOL  boostV	= b4  		; Boost Voltage set-point
	SYMBOL  floatV	= b5	  		; Float Voltage set-point
	SYMBOL  availA	= b6			; Available Amps for charging	(metered)			
	SYMBOL  TgenA	= b7			; Total Amps from gens (calculated data imported fron Piglet) 
	SYMBOL  duty	= w4			; PWM duty cycle
	SYMBOL  LoBattV	= b10			; Low Battery Voltage Alarm set-point
   	SYMBOL  loc		= b11			; EEPROM location
   	SYMBOL  datbyt	= b12			; data in byte from EEPROM
   	SYMBOL  rsbit     = b13			; no fucking idea
	SYMBOL  outby	= b14			; code for method of sending logging Data OUT BY
	SYMBOL  taperAT	= b15			; Amp Threshold before tapering
	SYMBOL  mode	= b16			; code for current mode of charging (for logging)
	SYMBOL  dumpA	= b17			; Dump Amps (calculated)
	SYMBOL  loadA	= b18			; Load Amps (calculated)
	SYMBOL  A4t		= b19			; Amps for tapering	
	SYMBOL  rangeV	= b20			; size of Volt range for amp tapering	
	SYMBOL  rangeA	= b21			; size  of Amp tapering range 	
	SYMBOL  solA	= b22			; Solar Amps (data imported fron Piglet)
	SYMBOL  winA	= b23			; Wind Amps (data imported fron Piglet)
	SYMBOL  hydA	= b24			; Hydro Amps (data imported fron Piglet)	
   	SYMBOL  repeat	= b25			; loop count
		
	EEPROM 0,( $33 ) 
	EEPROM 1,( $32 )
	EEPROM 2,( $28 )    
	EEPROM 3,( $0C )   
	EEPROM 4,( $06 )    
	EEPROM 5,( $01 )    	
	EEPROM 6,("    ")				; 4 x spaces
	EEPROM 10,("OK")
	EEPROM 12,("LOW BATTERY")
	EEPROM 23,("On BOOST")
	EEPROM 31,("On TAPER")
	EEPROM 39,("On FLOAT")
	EEPROM 47,("OVERLOAD")
	EEPROM 55,("Forced Dump")
	EEPROM 66,("Forced Boost")
	EEPROM 78,("Set Float Volts") 
	EEPROM 93,("Set Boost Volts")
	EEPROM 108,("Set LoBatt Volts")
	EEPROM 124,("Set NoTaper Amps")
	;EPROM 140					; LoBattV
	;EPROM 141					; boostV
	;EPROM 142					; floatV
	;EPROM 143					; taperAT (Taper Amps Threshold)
	;EPROM 144					; 'outby' code
	EEPROM 145,("Data to PC via..")
	EEPROM 161,("Serial for terminal")
	EEPROM 180,("Serial for W'mill  ")
	EEPROM 199,(" Radio for W'mill  ") 
	;EPROM 218	

	FOR loc = 0 TO 5				; Initialise the LCD display
	read loc,datbyt
	pause 15
	 Gosub SendCmdByte
	NEXT
	datbyt=1			
	 Gosub SendCmdByte
	datbyt = 192
	 Gosub SendCmdByte
	FOR loc = 6 TO 9				; set for 4 x spaces	
	read loc, datbyt
	 Gosub SendDataByte			; display spaces
	NEXT
	FOR loc = 10 TO 11
	read loc,datbyt
	 Gosub SendDataByte			; say "OK"
	NEXT
	high portc 2,3,4				; all LEDs - ON
	read 140, LoBattV
	read 141, boostV				; read in Boost Voltage Set-point saved in eeprom
	read 142, floatV
	read 143, taperAT	
	read 144, outby
	if boostV=0 then gosub SetDefaults	; check for an unsaved value
	rangeA = 100 - taperAT			; calc size of Amp range to apply tapering to (Max Amps In = 100Amps)
	rangeV = floatV - boostV		; Volt range to apply amp tapering to
	 Gosub Beep
	low portc 2,3,4				; all LEDs - OFF	
	goto Main
	
SetDefaults:					; This routine sets some default voltages if there are no preset values in the eeprom
	LoBattV = 12				; set- Low Batt Voltage Set-Point to 11.2 as default
	write 140, LoBattV			; save to eprom
	boostV = 40 				; set- Taper Voltage Set-Point to 14.0 as default
	write 141, boostV				; save to eeprom
	floatV = 47 				; set- Float Voltage Set-Point to 14.7 as default
	write 142,floatV				; save to eeprom
	taperAT = 20				; set- Amps Threshold before tapering to 20 as default
	write 143, taperAT			; save to eeprom
	return


; ########## Main Display & Select Charge Mode routine


Main:
	if pin0 = 1 then menu1			; is 'MENU' button pressed?
	if pin6 = 0 then ForcedBoost		; is 'Forced Boost' switch on? 
	if pin7 = 0 then ForcedDump		; is 'Forced Dump' switch on? 
	 Gosub GetValues
	datbyt = 2
	 Gosub SendCmdByte
	FOR loc = 6 TO 7				; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte			; display spaces
	NEXT
	 Gosub DisplayVolt			; display the variable 'Volts'
	datbyt = "V"
	 Gosub SendDataByte			; display "V"
	FOR loc = 6 TO 7				; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte			; display spaces
	NEXT

	 Gosub DisplayAmp				; display the variable 'BatAmp'
	datbyt = "A"
	 Gosub SendDataByte			; display "A"

	b0 = floatV - 1
	if BatAmp = 0 or BatAmp > 200 then HiDrainAlarm		; battery overloaded- sound alarm & switch to Boost charging			
	if Volt > b0 then if mode = "F" then Float1		; shortcut to same mode as before
	 else goto Float : endif 					; battery fully charged- switch to Float charging.   
	if Volt > boostV and availA > taperAT then if mode = "T" then Taper1 ; shortcut to same mode as before
	 else goto Taper : endif					; battery almost charged- switch to Taper charging.
	if Volt =< LoBattV then if mode = "L" then LBA 		; shortcut to same mode as before
	 else goto LowBattAlarm : endif				; very Low Battery Volts- sound alarm & switch to Boost charging
	if mode = "B" then Boost1		; shortcut to same mode as before
	goto Boost  				; battery low- switch to Boost charging

; ########## Send info to the screen routine.


SendCmdByte:
        rsbit = %00000000			; Send to Command register


SendDataByte:
	pins = datbyt & %11110000 | rsbit 	; put MSB out first
	pulsout 3,2					; give a 10uS pulse on E
	pins = datbyt * %00010000 | rsbit	; put LSB out second
	pulsout 3,2					; give a 10uS pulse on E
	rsbit = %00000100				; send to Data register next
	return


' ########## Read in Values & Send Data for Logging


GetValues:						; get values and send for logging
	readadc10 0,w0				; read the volts digital(adc) value
	Volt = w0 - 100 min 0 max 255		; to set up_ calibrate so the difference between 10v and 35.5v is a digital 255.
	 						; As we can only use bytes, subtract the 10v digital value to give us a range of 0 to 255.
							; 0 = 10 volts, 255 = 35.5 volts

	readadc 3, availA				; read Available Amps signal
	availA = availA - 27			; calculate Available Amps for graph logging (0 offset of 100 for + & - values) 				
	if availA > 200 then			; check for calc underflow
	availA = 0					; fix underflow error
	endif
	
	readadc 1, BatAmp				; read Battery Amps signal
	BatAmp = BatAmp - 22			; because 22=-100 amps, 122=0 amps, 222=100 amps (+ & - values when 0 is offset to 100)

	serin 5,N1200,("TW"),solA,winA,hydA,TgenA		; Amp data in from piglet
	loadA = TgenA + 100 - availA		; calc Load Amps
	if loadA > 100 then 			; check for calc underflow
	loadA = 0					; fix underflow error
	endif
	dumpA = availA - BatAmp			; calc Dump Amps
	if dumpA > 100 then			; check for calc underflow
	dumpA = 0					; fix underflow error
	endif
	
	on outby goto byWire1, byWire2, byAir	
byWire1:						; data to PC via seial cable for Programming Editor's or others Terminal logging
	sertxd ("__",#solA,"SA__",#winA,"WA__",#hydA,"HA__",#TgenA,"TA__",#Volt,"V__",#loadA,"LA__",mode,"__",#dumpA,"DA__",#BatAmp,"BA",cr,lf)
	return
byWire2:						; data to PC via serial cable for Windmill logging
	sertxd ("s",#solA,"w",#winA,"h",#hydA,"t",#TgenA,"v",#Volt,"l",#loadA,"m",mode,"d",#dumpA,"b",#BatAmp,cr,lf)
	return 
byAir: 						; data to radio TX module (suits Terminal & Windmill loggers)
	serout 0, T600, (85,85,85,"TW",solA,winA,hydA,TgenA,Volt,loadA,mode,dumpA,BatAmp)
	return



; ########## Alarm  routines


HiDrainAlarm:
	mode = "O"				; "O" for OVERLOAD
	datbyt = 192			; move to 2nd line on screen
	 Gosub SendCmdByte
	FOR loc = 6 TO 9			; set for 4 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 47 TO 54
	read loc, datbyt
	 Gosub SendDataByte		; display "OVERLOAD"
	NEXT
	high portc 2,3,4			; All LED _ ON		
	pwmout 1 OFF			; turn OFF PWM output
	low portc 1				; ensure (PWM) pin1 is low
HDA:
	pause 1000
	low portc 2,3,4			; All LED _ OFF           **** in simulation 3 & 4 won't OFF****
	 Gosub AlarmBeep2			; make a very bad noise!
	high portc 2,3,4			; All LED _ ON
	pause 1000
	goto Main


LowBattAlarm:
	mode = "L"				; "L" for LOW			
	datbyt = 192			; move to 2nd line on screen
	 Gosub SendCmdByte
	FOR loc = 6 TO 8			; set for 3 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 12 TO 22
	read loc, datbyt
	 Gosub SendDataByte		; display "LOW BATTERY"
	NEXT
	high portc 4			; Boost LED _ ON
	low portc 2,3			; Taper & Float LEDs _ OFF **** in simulation 3 won't OFF****

	pwmout 1 OFF			; turn OFF PWM output
	low portc 1				; ensure (PWM) pin1 is low
LBA:
 	 Gosub AlarmBeep1			; make a bad noise!
 	sleep 13				; 13 * 2.3 sec = 30 secs (also turns OFF PWM)

	goto Main


; ########## Battery Charging routines


Boost:
	mode = "B"				; "B" for BOOST
	datbyt = 192			; move to 2nd line on screen
	 Gosub SendCmdByte
	FOR loc = 6 TO 9			; set for 4 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 23 TO 30
	read loc, datbyt
	 Gosub SendDataByte		; display "On BOOST"
	NEXT
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	high portc 4			; Boost LED _ ON
	low portc 2,3			; Taper & Float LEDs _ OFF   **** in simulation 3 & 4 won't OFF****
	pwmout 1 OFF			; turn OFF PWM output
	low portc 1				; ensure PWM pin1 is low		
Boost1:
	sleep 4 				; 4 * 2.3 sec = 9.2 secs (also turns OFF PWM)

	goto Main


Taper:
	mode = "T"				; "T" for TAPER
	datbyt = 192			; move to 2nd line on screen
	 Gosub SendCmdByte
	FOR loc = 6 TO 9			; set for 4 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc= 31 TO 38
	read loc, datbyt
       Gosub SendDataByte		; display "On TAPER"
	NEXT
	high portc 2			; Taper LED _ ON
	low portc 3,4			; Float & Boost LEDs _ OFF 
Taper1:
  	FOR repeat = 1 to 255		; start a 255 times loop (max = 256)
	readadc 2, availA			; Reads Available Amps signal
	availA = availA-127
	if availA > 100 or availA =< taperAT then Boost			; check for underflow
	A4t = availA - taperAT 							; Amps for tapering
	duty = Volt-boostV*1000/rangeV/rangeA*A4t min 0 max 1000 
	pwmout 1, 249, duty							; update duty cycle. 249 = 4kHz @ 4MHz
	readadc10 0, w0			; read in volt's ADC signal
	Volt = w0 - 100
	NEXT repeat

	goto Main



Float:
	mode = "F"				; "F" for FLOAT
	datbyt = 192			; move to 2nd line on screen
	 Gosub SendCmdByte
	FOR loc = 6 TO 9			; set for 4 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 39 TO 46
	read loc, datbyt
	 Gosub SendDataByte		; display "On FLOAT"
	NEXT
	low portc 2,4			; Taper & Boost LED _ OFF
	high portc 3			; Float LED _ ON
Float1:
	FOR repeat = 1 to 255		; start a 255 times loop (max = 256)	
	if volt > floatV then if duty < 1000 then inc duty: endif 	; if over voltage then increment duty
	else if duty > 0 then dec duty: endif  				; otherwise decrement duty
	pwmout 1, 249, duty		; update duty cycle. 249 = 4kHz @ 4MHz
	readadc10 0, w0			; read in volt's ADC signal
	Volt = w0 - 100
	NEXT repeat

	goto Main


; ########## Display Volts and Amps routine


DisplayVoltLine2:
	datbyt = 192 			; move to 2nd line on screen		
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT

DisplayVolt:				; the routine breaks up the voltage into digits and displays each in turn
	b0 = Volt
	b1=b0/100
	datbyt=b1+49			; adds 1 to the ASCII digit value
	 Gosub SendDataByte		; display 'Volt' hundreds
	b1=b1*100
	b0=b0-b1
	b1=b0/10
	datbyt=b1+48
	 Gosub SendDataByte		; display 'Volt' tens
	datbyt = "."
	 Gosub SendDataByte		; display "." point
	b1=b1*10
	b0=b0-b1
	b1=b0
	datbyt=b1+48
	 Gosub SendDataByte		; display 'Volt' units
	return

DisplayAmpLine2:
	datbyt = 192 			; move to 2nd line on screen		
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	 BatAmp = taperAT + 100

DisplayAmp:					;  same as above, but adds the + or -  symbol for current input or drain
	
	if BatAmp>100 then pamp
	if BatAmp<100 then namp
	if BatAmp=100 then oamp
	
  pamp:					; positive Amps
  	datbyt = " "			; "space" ("+" looks odd so substituting a space)
	 Gosub SendDataByte		; display a '+' sign
	b0 = BatAmp - 100
	goto DA1
  namp:					; negative Amps
	datbyt = "-"
	 Gosub SendDataByte		; display a "-" sign
	b0 = 100 - BatAmp
	goto DA1
  oamp:					; 0 Amps
  	datbyt = " "			; "space"
	 Gosub SendDataByte		; display a fill-in space
	b0=0
	goto DA1
  DA1:					; display variable 'BattAmps'
	b1=b0/100
	datbyt=b1+48
	 Gosub SendDataByte		; display 'BattAmps' hundreds
	b1=b1*100
	b0=b0-b1
	b1=b0/10
	datbyt=b1+48
	 Gosub SendDataByte		; display 'BattAmps' tens
	b1=b1*10
	b0=b0-b1
	b1=b0
	datbyt=b1+48
	 Gosub SendDataByte		; display 'BattAmps' units
	return


; ########  Menu's Setup routine


Menu1:					; resets the Boost Voltage set-point 'boostV'
	 Gosub Beep	
	pause 500
	datbyt = 1
	 Gosub SendCmdByte
	datbyt = 128
	 Gosub SendCmdByte
	FOR loc = 93 TO 107
	read loc, datbyt
	 Gosub SendDataByte		; display "Set Boost Volts"
	NEXT
	Volt = boostV
	 Gosub DisplayVoltLine2
	dirsc = %00000010	 		; change pins from output (for LED's) to input (for Menu buttons) 
Menu1a:
	pause 200
	if pin0 = 1 then Menu2
	if pin2 = 1 then DownBoostV
	if pin3 = 1 then UpBoostV
	goto Menu1a

UpBoostV:
	boostV = boostV + 1
	Volt = boostV
	 Gosub DisplayVoltLine2
	write 141,boostV			; save in eeprom
	goto Menu1a

DownBoostV:
	boostV = boostV - 1
	Volt = boostV
	 Gosub DisplayVoltLine2
	write 141,boostV			; save in eeprom
	goto Menu1a

Menu2:					; resets the Float Voltage set-point 'floatV'
	 Gosub Beep
	datbyt = 1
	 Gosub SendCmdByte
	datbyt = 128
	 Gosub SendCmdByte
	FOR loc = 78 TO 92		; display "Set Float Volts"
	read loc, datbyt
	 Gosub SendDataByte
	NEXT
	Volt = floatV
	 Gosub DisplayVoltLine2
Menu2a:
	pause 200
	if pin0 = 1 then Menu3
	if pin2 = 1 then DownFloatV
	if pin3 = 1 then UpFloatV
	goto Menu2a

UpFloatV:
	floatV = floatV + 1
	Volt = floatV
	 Gosub DisplayVoltLine2
	write 142,floatV			; save in eeprom
	goto Menu2a

DownFloatV:
	floatV = floatV - 1
	Volt = floatV
	 Gosub DisplayVoltLine2
	write 142,floatV			; save in eeprom
	goto Menu2a

Menu3:					; resets the Low Batt alarm voltage set-point 'LoBattV'
	 Gosub Beep
	datbyt = 1
	 Gosub SendCmdByte
	datbyt = 128
	 Gosub SendCmdByte    
	FOR loc = 108 TO 123
	read loc, datbyt
	 Gosub SendDataByte		; display "Set LoBatt V"
	NEXT
	Volt = LoBattV
	 Gosub DisplayVoltLine2
Menu3a:
	pause 200
	if pin0 = 1 then Menu4
	if pin2 = 1 then DownLoBattVolt
	if pin3 = 1 then UpLoBattVolt
	goto Menu3a

UpLoBattVolt:
	LoBattV = LoBattV + 1
	Volt = LoBattV
	 Gosub DisplayVoltLine2
	write 140,LoBattV			; save in eeprom
	goto Menu3a

DownLoBattVolt:
	LoBattV = LoBattV - 1
	Volt = LoBattV
	 Gosub DisplayVoltLine2
	write 140,LoBattV			; save in eeprom
	goto Menu3a

Menu4:					; resets the Taper Amps Threshold 'taperAT'
	 Gosub Beep
	datbyt = 1
	 Gosub SendCmdByte
	datbyt = 128
	 Gosub SendCmdByte
	FOR loc = 124 TO 139		; display "Set Taper A"
	read loc, datbyt
	 Gosub SendDataByte
	NEXT
	 Gosub DisplayAmpLine2
Menu4a:
	pause 200
	if pin0 = 1 then Menu5
	if pin2 = 1 then DowntaperAT
	if pin3 = 1 then UptaperAT
	goto Menu4a

UptaperAT:
	taperAT = taperAT + 1
	 Gosub DisplayAmpLine2
	write 143,taperAT			; save in eeprom
	goto Menu4a

DowntaperAT:
	taperAT = taperAT - 1
	 Gosub DisplayAmpLine2
	write 143,taperAT			; save in eeprom	
	goto Menu4a
	
Menu5:					; resets the 'Data to PC via..' mode 
	 Gosub Beep
	datbyt = 1
	 Gosub SendCmdByte
	datbyt = 128
	 Gosub SendCmdByte    
	FOR loc = 145 TO 160
	read loc, datbyt
	 Gosub SendDataByte		; display "Data to PC via.."
	NEXT
	Volt = LoBattV
 	datbyt = 192 			; move to 2nd line on screen		
	 Gosub SendCmdByte
	on outby goto Serial4T, Serial4W, Radio
 	 
	 
Serial4T:					; data out by Serial Cable for Editor's Terminal window
	pause 200
	FOR loc = 161 TO 179			
	read loc, datbyt
	 Gosub SendDataByte		; display "Serial for terminal"
	NEXT
	DO until pin0 = 1
	if pin2 =1 then Radio
	if pin3 =1 then Serial4W
	LOOP
	gosub Beep
	outby = 0
	write 144, outby
	goto Start  

Serial4W:					; data out by Serial Cable for the Windmill DataLogging Programme
	pause 200
	FOR loc = 180 TO 198			
	read loc, datbyt
	 Gosub SendDataByte		; display "Serial for W'mill"
	NEXT
	DO until pin0 = 1
	if pin2 =1 then Serial4T
	if pin3 =1 then Radio
	LOOP
	gosub Beep
	outby = 1
	write 144, outby
	goto Start  
	 
Radio:					; for Windmill but Terminal can also log though data is squashed up	
	pause 200 
	FOR loc = 199 TO 217			
	read loc, datbyt
	 Gosub SendDataByte		; display "Radio for W'mill"
	NEXT
	DO until pin0 = 1
	if pin2 =1 then Serial4W
	if pin3 =1 then Serial4T 
	LOOP
	gosub Beep
	outby = 2
	write 144, outby
	goto Start
	


; ########## Forced Boost/Dump routines.


ForcedBoost:
	 Gosub Beep
	high portc 2,3,4			; all LED _ ON
	pause 1500
	pwmout 1 OFF			; PWM pin output _ OFF
	low portc 1				; battery charging full _ ON
	low portc 2,3			; Taper & Float LEDs _ OFF
	mode = "X"				; "X" for eXtra special manual charging mode
	datbyt = 192
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 66 TO 77
	read loc, datbyt
	 Gosub SendDataByte		; display "Forced Boost"
	NEXT

ForcedBoost1:
	if pin6 = 1 then Start 
	 Gosub GetValues
	datbyt = 2
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	 Gosub DisplayVolt		; display 'Volt'	
	datbyt = "V"
	 Gosub SendDataByte		; display "V"
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	 Gosub DisplayAmp			; display 'BatAmp'
	datbyt = "A"
	 Gosub SendDataByte		; display "A"
	nap 7					; = 2.3secs (max nap)
	goto ForcedBoost1



ForcedDump:
	 Gosub Beep
	pwmout 1 OFF			; PWM pin output _ OFF
	high portc 1			; dump load full _ ON
	mode = "Y"				; "Y" for Why do I need this mode again?
	datbyt = 192
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	FOR loc = 55 TO 65
	read loc, datbyt
	 Gosub SendDataByte		; display "Forced Dump"
	NEXT

ForcedDump1:
	if pin7 = 1 then Start
	 Gosub GetValues
	datbyt = 2
	 Gosub SendCmdByte
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	 Gosub DisplayVolt		; display 'Volt'
	datbyt = "V"
	 Gosub SendDataByte		; display "V"
	FOR loc = 6 TO 7			; set for 2 x spaces	
	read loc, datbyt
	 Gosub SendDataByte		; display spaces
	NEXT
	 Gosub DisplayAmp			; display 'BatAmp'	
	datbyt = "A"
	 Gosub SendDataByte		; display "A"
	pause 3000
	high portc 2,3,4			; all LEDs _ ON
	 Gosub AlarmBeep1
	pause 1000
	low portc 2,3,4			; all LED _ OFF
	goto ForcedDump1



; ########## Sound routines


Beep:						; make an OK noise
	high 1: pause 50
	low 1: pause 20
	high 1: pause 50			; RoadRunner's bee-beep
	low 1: pause 500
	return

AlarmBeep1:					; make a WARNING noise
	high 1: pause 600
	low 1
	return

AlarmBeep2:					; make a Serious WARNING noise
	for b0 = 1 to 3
	high 1: pause 700			; morse code "K" = "over to you" 
	low 1: pause 100
	high 1: pause 100		
	low 1: pause 100
	high 1: pause 700
	low 1: pause 700
	next
	return


END

























































































